//ランタンのスケッチ
//2013.09.29

//Xbee通信用ソフトウェアシリアル
#include <SoftwareSerial.h>
SoftwareSerial mySerial(3, 2); // RX, TX

//LEDピンのアサイン
#define  RED    9
#define  GREEN  10
#define  BLUE   6
#define  WHITE  5

//ゆらぎの配列
const char HOTARU[]={
  27,25,24,23,23,23,23,21,21,19,19,18,18,17,17,
  17,16,16,15,15,15,16,17,17,17,17,17,17,17,19,24,32,
  39,41,40,37,34,30,28,26,27,30,33,33,31,29,26,24,23,
  22,26,52,113,174,219,232,215,184,154,124,102,96,114,
  154,205,229,230,200,162,138,113,93,85,83,82,81,80,79,
  73,66,59,50,45,39,35,34,35,37,36,36,34,31,28,26,26,28,
  43,63,72,72,65,56,49,43,41,48,73,104,135,153,151,129,
  109,94,82,68,63,62,62,58,55,51,45,41,37,33,29,26,24,
  23,21,21,20,19,19,19,19,20,20,20,19,19,19,18,18,18,
  22,42,63,94,106,104,92,78,65,56,49,44,45,52,61,65,63,
  58,51,45,42,43,53,74,107,123,124,110,94,78,67,57,53,
  64,94,135,185,207,196,168,139,115,95,84,83,115,155,
  186,200,180,153,125,104,88,74,64,64,78,95,106,104,94,
  82,67,57,51,47,47,48,49,46,42,37,33,30,28,25,24,22,
  21,19,19,19,19,19,19,18,18,18,18,18,18,18,18,19,19,
  21,21,22,21,20,20,20,19,19,19,19,18,18,18,17,18,24,
  37,69,103,112,105,90,73,61,52,45,41,39,38,39,40,38,
  36,32,29,27,25,23,23,24,33,45,69,80,77,70,62,54,46,
  41,36,37,47,74,101,125,124,111,93,78,65,56,48,43,
  38,36,38,40,41,39,34,31,28};


int RcvData;
int i = 0;
float Bright;
int counter;
int lastData;
int ledStatus;
int cnt = 0;
int cnt_Led = 10;
int cnt_Blue = 20;
int cnt_Green = 30;


//セットアップ
void setup(){
  pinMode(RED, OUTPUT);
  pinMode(GREEN, OUTPUT);
  pinMode(BLUE, OUTPUT);
  pinMode(WHITE, OUTPUT);

  analogWrite(RED,0);
  analogWrite(GREEN,0);
  analogWrite(BLUE,0);
  analogWrite(WHITE,0);

  mySerial.begin(9600);
  Serial.begin(9600);
}



//ループ
void loop(){ 
  counter++;

  //マジカルステッキからの信号がきたら
  while(mySerial.available()>0){
    RcvData = mySerial.read();
  }

  Serial.println(RcvData); 

  //信号が'a'なら
  if(RcvData=='a'){
    //もし直前に受け取ったデータ（lastData）が、'a'でなければ
    if(lastData!='a'){
      counter = 0;
      ledStatus = 1;
    }
  }
  //信号が’b’なら
  else if(RcvData=='b'){
    //もし直前に受け取ったデータ（lastData）が、'b'でなければ
    if(lastData!='b'){
      counter = 0;
      ledStatus = 2; 
    }
  }
  //信号が’c’なら
  else if(RcvData=='c'){
    //もし直前に受け取ったデータ（lastData）が、'c'でなければ
    if(lastData!='c'){
      ledStatus = 3; 
    }
  }
  //それ以外のとき
  else{
    ledStatus = 0;
  }


  //受け取った信号ごとの処理
  switch(ledStatus){
  case 1:
    //暖色に変化していく
    analogWrite(RED, counter%256);
    analogWrite(GREEN, (255-(counter%256))*30/100);
    analogWrite(BLUE, 255-(counter%256));
    break;

  case 2:     
    //寒色に変化していく
    analogWrite(RED, (255-(counter%256))*50/100);
    analogWrite(GREEN,(255-(counter%256))*30/100);
    analogWrite(BLUE, counter%256);
    break;

  case 3:
    //ゆらぎ効果をだす
    cnt++;
    cnt_Led++;
    cnt_Blue++;
    cnt_Green++; 

    analogWrite(WHITE,HOTARU[cnt%sizeof(HOTARU)]);
    analogWrite(RED,HOTARU[cnt_Led%sizeof(HOTARU)]);
    analogWrite(BLUE,HOTARU[cnt_Blue%sizeof(HOTARU)]);
    analogWrite(GREEN,HOTARU[cnt_Green%sizeof(HOTARU)]);
    break;
  }

  //少しまつ（LED変化の速さを調整する）
  delay(50);
  
  //今のデータをlastDataにする
  lastData=RcvData;

}





