//マジカルステッキのスケッチ
//2013.09.29

//LEDピンのアサイン
#define RED  5
#define GRN  6
#define BLU  3

//デバッグモード
#define DBG  2

int  Xscale;
int  Yscale;
int  Zscale;
int  volume;

int  RED_val;
int  GRN_val;
int  BLU_val;

int  Xset;
int  Yset;
int  Zset;
int  state;

int  debug;

//セットアップ
void setup(){
  debug = DBG;

  Xset = 0;
  Yset = 0;
  Zset = 0;

  state = 0;

  volume = 1023;

  if(debug == 1){
    Serial.begin(9600);
    while (!Serial) {
      ; // wait for serial port to connect. Needed for Leonardo only
    }
  }

  // xbee
  Serial1.begin(9600);   
  while (!Serial1) {
    ; // wait for serial port to connect. Needed for Leonardo only
  }

}


//ループ
void loop(){

  // 角度センサ
  Zscale = (analogRead(A0));
  Xscale = (analogRead(A1));
  Yscale = (analogRead(A2));
  // 圧電センサ
  volume = (analogRead(A3));

  Zscale = Zscale - 512;
  Xscale = Xscale - 512;
  Yscale = Yscale - 512;

  volume = volume/4;

  // color set
  // average * 15/16 + float(analog(A0)/16));
  if(Zscale >= 0){
    // Zscale = Zscale;
    Zscale = 512;
    Zset = 0;
  }  
  else if(Zscale < 0){
    // Zscale = abs(Zscale);
    Zscale = 0;
    Zset = 1;
  }

  if(Xscale >= 0){
    // Xscale = Xscale;
    Xscale = 512;
    Xset = 0;
  }
  else if(Xscale < 0){
    // Xscale = abs(Xscale);
    Xscale = 0;
    Xset = 1;
  }

  if(Yscale >= 0){
    // Yscale = Yscale;
    Yscale = 512;
    Yset = 0;
  }
  else if(Yscale < 0){
    // Yscale = abs(Yscale);
    Yscale = 0;
    Yset = 1;
  }

  RED_val = 255 - (Zscale/2 * volume/256);
  GRN_val = 255 - (Xscale/2 * volume/256);
  BLU_val = 255 - (Yscale/2 * volume/256);

  //  LED
  analogWrite(RED, RED_val);
  analogWrite(GRN, GRN_val);
  analogWrite(BLU, BLU_val);

  // event a, b, c 
  if((Xset == 1) and (Yset == 0) and (Zset = 1)){
    Serial1.write('a');
    state = 1;
  }
  else if((Xset == 0) and (Yset == 0) and (Zset = 1)){
    Serial1.write('b');
    state = 2;
  }
  else if((Xset == 1) and (Zset == 1) and (state == 3)){
    state = 4;
    delay(1000);
  }
  else if((Xset == 0) and (Zset == 1) and (state == 4)){
    state = 5;
    delay(1000);
    Serial1.write('c');
  }
  else if((Zset == 0)){
    state = 3;
  }
  else {
    state = 0;
  }


  if(debug == 1){
    // 加速度センサ確認  UART
    Serial.print("Zscale");
    Serial.print(",");
    Serial.print(Zscale);
    Serial.print(",");
    Serial.print("Xscale");
    Serial.print(",");
    Serial.print(Xscale);
    Serial.print(",");
    Serial.print("Yscale");
    Serial.print(",");
    Serial.print(Yscale);
    Serial.print(",");
    Serial.print("BLU_val");
    Serial.print(",");
    Serial.print(BLU_val);
    Serial.print(",");

    Serial.print("volume");
    Serial.print(",");
    Serial.print(volume);
    Serial.print(",");

    Serial.print("** Xset **");
    Serial.print(",");
    Serial.print(Xset);
    Serial.print(",");
    Serial.print("** Yset **");
    Serial.print(",");
    Serial.print(Yset);
    Serial.print(",");
    Serial.print("** Zset **");
    Serial.print(",");
    Serial.print(Zset);
    Serial.print(",");

    Serial.print("state");
    Serial.print(",");
    Serial.print(state);
    Serial.print(",");

    Serial.println("");

  }
  else if(debug == 2){
    // 加速度センサ確認  xbee
    // Serial1.write((analogRead(A0)/4));
    ;
  }

  delay(50);
}


